3 # Copyright (c) 2005 Junio C Hamano
6 USAGE='[-n] [--summary] [--[no-]commit] [--[no-]squash] [--[no-]ff] [-s <strategy>] [-m=<merge-message>] <commit>+'
13 test -z "$(git ls-files -u)" ||
14 die "You are in the middle of a conflicted merge."
19 all_strategies='recur recursive octopus resolve stupid ours subtree'
20 default_twohead_strategies='recursive'
21 default_octopus_strategies='octopus'
22 no_fast_forward_strategies='subtree ours'
23 no_trivial_strategies='recursive recur subtree ours'
30 rm -f -- "$GIT_DIR/MERGE_HEAD" "$GIT_DIR/MERGE_MSG" \
31 "$GIT_DIR/MERGE_STASH" || exit 1
35 # Stash away any local modifications.
36 git stash create >"$GIT_DIR/MERGE_STASH"
40 if test -f "$GIT_DIR/MERGE_STASH"
42 git reset --hard $head >/dev/null
43 git stash apply $(cat "$GIT_DIR/MERGE_STASH")
44 git update-index --refresh >/dev/null
48 finish_up_to_date () {
51 echo "$1 (nothing to squash)" ;;
59 echo Squashed commit of the following:
61 git log --no-merges ^"$head" $remoteheads
67 rlogm="$GIT_REFLOG_ACTION"
70 rlogm="$GIT_REFLOG_ACTION: $2"
74 echo "Squash commit -- not updating HEAD"
75 squash_message >"$GIT_DIR/SQUASH_MSG"
80 echo "No merge message -- not updating HEAD"
83 git update-ref -m "$rlogm" HEAD "$1" "$head" || exit 1
93 if test "$show_diffstat" = t
95 # We want color (if set), but no pager
96 GIT_PAGER='' git diff --stat --summary -M "$head" "$1"
101 # Run a post-merge hook
102 if test -x "$GIT_DIR"/hooks/post-merge
106 "$GIT_DIR"/hooks/post-merge 1
109 "$GIT_DIR"/hooks/post-merge 0
117 rh=$(git rev-parse --verify "$remote^0" 2>/dev/null) || return
118 bh=$(git show-ref -s --verify "refs/heads/$remote" 2>/dev/null)
119 if test "$rh" = "$bh"
121 echo "$rh branch '$remote' of ."
122 elif truname=$(expr "$remote" : '\(.*\)~[1-9][0-9]*$') &&
123 git show-ref -q --verify "refs/heads/$truname" 2>/dev/null
125 echo "$rh branch '$truname' (early part) of ."
126 elif test "$remote" = "FETCH_HEAD" -a -r "$GIT_DIR/FETCH_HEAD"
128 sed -e 's/ not-for-merge / /' -e 1q \
129 "$GIT_DIR/FETCH_HEAD"
131 echo "$rh commit '$remote'"
137 -n|--n|--no|--no-|--no-s|--no-su|--no-sum|--no-summ|\
138 --no-summa|--no-summar|--no-summary)
139 show_diffstat=false ;;
142 --sq|--squ|--squa|--squas|--squash)
143 allow_fast_forward=t squash=t no_commit=t ;;
144 --no-sq|--no-squ|--no-squa|--no-squas|--no-squash)
145 allow_fast_forward=t squash= no_commit= ;;
146 --c|--co|--com|--comm|--commi|--commit)
147 allow_fast_forward=t squash= no_commit= ;;
148 --no-c|--no-co|--no-com|--no-comm|--no-commi|--no-commit)
149 allow_fast_forward=t squash= no_commit=t ;;
151 allow_fast_forward=t squash= no_commit= ;;
153 allow_fast_forward=false squash= no_commit= ;;
154 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
155 --strateg=*|--strategy=*|\
156 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
159 strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
166 case " $all_strategies " in
168 use_strategies="$use_strategies$strategy " ;;
170 die "available strategies are: $all_strategies" ;;
173 -m=*|--m=*|--me=*|--mes=*|--mess=*|--messa=*|--messag=*|--message=*)
174 merge_msg=`expr "z$1" : 'z-[^=]*=\(.*\)'`
177 -m|--m|--me|--mes|--mess|--messa|--messag|--message)
195 parse_option "$@" || usage
196 while test $args_left -lt $#
203 test $# != 0 || usage
207 if branch=$(git-symbolic-ref -q HEAD)
209 mergeopts=$(git config "branch.${branch#refs/heads/}.mergeoptions")
210 if test -n "$mergeopts"
212 parse_config $mergeopts
216 while parse_option "$@"
218 while test $args_left -lt $#
224 if test -z "$show_diffstat"; then
225 test "$(git config --bool merge.diffstat)" = false && show_diffstat=false
226 test -z "$show_diffstat" && show_diffstat=t
229 # This could be traditional "merge <msg> HEAD <commit>..." and the
230 # way we can tell it is to see if the second token is HEAD, but some
231 # people might have misused the interface and used a committish that
232 # is the same as HEAD there instead. Traditional format never would
233 # have "-m" so it is an additional safety measure to check for it.
235 if test -z "$have_message" &&
236 second_token=$(git rev-parse --verify "$2^0" 2>/dev/null) &&
237 head_commit=$(git rev-parse --verify "HEAD" 2>/dev/null) &&
238 test "$second_token" = "$head_commit"
244 elif ! git rev-parse --verify HEAD >/dev/null 2>&1
246 # If the merged head is a valid one there is no reason to
247 # forbid "git merge" into a branch yet to be born. We do
248 # the same for "git pull".
251 echo >&2 "Can merge only exactly one commit into empty head"
255 rh=$(git rev-parse --verify "$1^0") ||
256 die "$1 - not something we can merge"
258 git update-ref -m "initial pull" HEAD "$rh" "" &&
259 git read-tree --reset -u HEAD
263 # We are invoked directly as the first-class UI.
266 # All the rest are the commits being merged; prepare
267 # the standard merge summary message to be appended to
268 # the given message. If remote is invalid we will die
269 # later in the common codepath so we discard the error
271 merge_name=$(for remote
274 done | git fmt-merge-msg
276 merge_msg="${merge_msg:+$merge_msg$LF$LF}$merge_name"
278 head=$(git rev-parse --verify "$head_arg"^0) || usage
280 # All the rest are remote heads
281 test "$#" = 0 && usage ;# we need at least one remote head.
282 set_reflog_action "merge $*"
287 remotehead=$(git rev-parse --verify "$remote"^0 2>/dev/null) ||
288 die "$remote - not something we can merge"
289 remoteheads="${remoteheads}$remotehead "
290 eval GITHEAD_$remotehead='"$remote"'
291 export GITHEAD_$remotehead
293 set x $remoteheads ; shift
295 case "$use_strategies" in
299 var="`git config --get pull.twohead`"
302 use_strategies="$var"
304 use_strategies="$default_twohead_strategies"
307 var="`git config --get pull.octopus`"
310 use_strategies="$var"
312 use_strategies="$default_octopus_strategies"
318 for s in $use_strategies
320 for ss in $no_fast_forward_strategies
329 for ss in $no_trivial_strategies
333 allow_trivial_merge=f
342 common=$(git merge-base --all $head "$@")
345 common=$(git show-branch --merge-base $head "$@")
348 echo "$head" >"$GIT_DIR/ORIG_HEAD"
350 case "$allow_fast_forward,$#,$common,$no_commit" in
352 # No common ancestors found. We need a real merge.
355 # If head can reach all the merge then we are up to date.
356 # but first the most common case of merging one remote.
357 finish_up_to_date "Already up-to-date."
361 # Again the most common case of merging one remote.
362 echo "Updating $(git rev-parse --short $head)..$(git rev-parse --short $1)"
363 git update-index --refresh 2>/dev/null
365 if test -n "$have_message"
367 msg="$msg (no commit created; -m option ignored)"
369 new_head=$(git rev-parse --verify "$1^0") &&
370 git read-tree -v -m -u --exclude-per-directory=.gitignore $head "$new_head" &&
371 finish "$new_head" "$msg" || exit
376 # We are not doing octopus and not fast forward. Need a
380 # We are not doing octopus, not fast forward, and have only
382 git update-index --refresh 2>/dev/null
383 case "$allow_trivial_merge" in
385 # See if it is really trivial.
386 git var GIT_COMMITTER_IDENT >/dev/null || exit
387 echo "Trying really trivial in-index merge..."
388 if git read-tree --trivial -m -u -v $common $head "$1" &&
389 result_tree=$(git write-tree)
393 printf '%s\n' "$merge_msg" |
394 git commit-tree $result_tree -p HEAD -p "$1"
396 finish "$result_commit" "In-index merge"
404 # An octopus. If we can reach all the remote we are up to date.
408 common_one=$(git merge-base --all $head $remote)
409 if test "$common_one" != "$remote"
415 if test "$up_to_date" = t
417 finish_up_to_date "Already up-to-date. Yeeah!"
423 # We are going to make a new commit.
424 git var GIT_COMMITTER_IDENT >/dev/null || exit
426 # At this point, we need a real merge. No matter what strategy
427 # we use, it would operate on the index, possibly affecting the
428 # working tree, and when resolved cleanly, have the desired tree
429 # in the index -- this means that the index must be in sync with
430 # the $head commit. The strategies are responsible to ensure this.
432 case "$use_strategies" in
434 # Stash away the local changes so that we can try more than one.
439 rm -f "$GIT_DIR/MERGE_STASH"
444 result_tree= best_cnt=-1 best_strategy= wt_strategy=
446 for strategy in $use_strategies
448 test "$wt_strategy" = '' || {
449 echo "Rewinding the tree to pristine..."
452 case "$single_strategy" in
454 echo "Trying merge strategy $strategy..."
458 # Remember which strategy left the state in the working tree
459 wt_strategy=$strategy
461 git-merge-$strategy $common -- "$head_arg" "$@"
463 if test "$no_commit" = t && test "$exit" = 0
466 exit=1 ;# pretend it left conflicts.
469 test "$exit" = 0 || {
471 # The backend exits with 1 when conflicts are left to be resolved,
472 # with 2 when it does not handle the given merge at all.
474 if test "$exit" -eq 1
477 git diff-files --name-only
478 git ls-files --unmerged
480 if test $best_cnt -le 0 -o $cnt -le $best_cnt
482 best_strategy=$strategy
489 # Automerge succeeded.
490 result_tree=$(git write-tree) && break
493 # If we have a resulting tree, that means the strategy module
494 # auto resolved the merge cleanly.
495 if test '' != "$result_tree"
497 if test "$allow_fast_forward" = "t"
499 parents=$(git show-branch --independent "$head" "$@")
501 parents=$(git rev-parse "$head" "$@")
503 parents=$(echo "$parents" | sed -e 's/^/-p /')
504 result_commit=$(printf '%s\n' "$merge_msg" | git commit-tree $result_tree $parents) || exit
505 finish "$result_commit" "Merge made by $wt_strategy."
510 # Pick the result from the best strategy and have the user fix it up.
511 case "$best_strategy" in
514 case "$use_strategies" in
516 echo >&2 "No merge strategy handled the merge."
519 echo >&2 "Merge with strategy $use_strategies failed."
525 # We already have its result in the working tree.
528 echo "Rewinding the tree to pristine..."
530 echo "Using the $best_strategy to prepare resolving by hand."
531 git-merge-$best_strategy $common -- "$head_arg" "$@"
535 if test "$squash" = t
542 done >"$GIT_DIR/MERGE_HEAD"
543 printf '%s\n' "$merge_msg" >"$GIT_DIR/MERGE_MSG"
546 if test "$merge_was_ok" = t
549 "Automatic merge went well; stopped before committing as requested"
556 git ls-files --unmerged |
557 sed -e 's/^[^ ]* / /' |
559 } >>"$GIT_DIR/MERGE_MSG"
561 die "Automatic merge failed; fix conflicts and then commit the result."